<script>
import Vue from "vue";

import { SlpButton, SlpIcon } from "slippers-ui";

import SlpNavigationMobileMenu from "./navigation-mobile-menu.vue";

import ArrowIcon from "../../assets/arrow.vue";
import GitLabIcon from "../../assets/gitlab2.vue";
import HamburgerIcon from "../../assets/hamburger.vue";
import SearchIcon from "../../assets/search.vue";
import SlpSearch from "../Search/search.vue";

export default Vue.extend({
  name: "SlpNavigationMobile",
  components: {
    ArrowIcon,
    GitLabIcon,
    HamburgerIcon,
    SearchIcon,
    SlpButton,
    SlpNavigationMobileMenu,
    SlpIcon,
    SlpSearch,
  },
  props: {
    navigationData: {
      required: true,
      type: Object,
    },
    freeTrialLink: {
      required: true,
      type: String,
    },
    hideSalesButton: {
      required: true,
      type: Boolean,
    },
  },
  data() {
    return {
      isMenuOpen: false,
      isSearchOpen: false,
      logoUrl: this.navigationData.logo.fields.url.content[0].content[0].value,
    };
  },
  methods: {
    toggleNavMenu() {
      this.isSearchOpen = false;
      this.isMenuOpen = !this.isMenuOpen;
    },
    toggleSearch() {
      this.isSearchOpen = !this.isSearchOpen;
    },
  },
});
</script>

<template>
  <div>
    <SlpSearch ref="slpSearch" v-show="isSearchOpen" @close="toggleSearch" />
    <div class="be-nav-tablet">
      <SlpButton variant="icon" href="/">
        <GitLabIcon ariaId="tanukiHomeTablet" />
      </SlpButton>
      <div>
        <!-- Talk to an expert button for Tablets -->
        <SlpButton
          v-if="!hideSalesButton"
          :href="navigationData.sales.href"
          variant="secondary"
          class="slp-mr-8"
          v-bind="navigationData.sales.headerGa"
        >
          {{ navigationData.sales.text }}
        </SlpButton>
        <SlpButton
          :href="freeTrialLink"
          variant="primary"
          v-bind="navigationData.freeTrial.headerGa"
        >
          {{ navigationData.freeTrial.text }}
        </SlpButton>
        <SlpButton
          variant="icon"
          :href="navigationData.login.href"
          class="slp-ml-16"
          v-bind="navigationData.login.headerGa"
          aria-label="Login"
        >
          <SlpIcon name="user" variant="product" slp-color="primary-200" />
        </SlpButton>
        <SlpButton
          variant="icon"
          class="slp-ml-16 search-icon"
          @click.native="toggleSearch()"
          aria-label="search"
          data-nav="site search"
        >
          <SearchIcon fill="#171321" />
        </SlpButton>
        <SlpButton
          variant="icon"
          class="slp-ml-16"
          @click.native="toggleNavMenu()"
          aria-label="Main menu"
        >
          <HamburgerIcon />
        </SlpButton>
      </div>
    </div>
    <div class="be-nav-phone">
      <SlpButton
        :href="freeTrialLink"
        variant="primary"
        class="navigation-top"
        v-bind="navigationData.freeTrial.headerGa"
      >
        {{ navigationData.freeTrial.text }}
        <ArrowIcon class="slp-ml-4" direction="right" fill="#fff" />
      </SlpButton>
      <div class="navigation-bottom">
        <SlpButton
          variant="icon"
          @click.native="
            $refs.slpSearch.searchResults
              ? $refs.slpSearch.cleanSearchResults()
              : toggleSearch()
          "
          aria-label="search"
          data-nav="site search"
          class="search-icon"
        >
          <SearchIcon fill="#171321" />
        </SlpButton>
        <SlpButton
          variant="icon"
          :href="logoUrl"
          data-nav="logo"
          aria-label="Home"
          name="Home"
        >
          <GitLabIcon ariaId="tanukiHomeMobile" :size="24" />
        </SlpButton>
        <SlpButton
          variant="icon"
          class="slp-ml-16"
          @click.native="toggleNavMenu()"
          aria-label="Main menu"
        >
          <HamburgerIcon />
        </SlpButton>
      </div>
    </div>
    <SlpNavigationMobileMenu
      v-if="isMenuOpen"
      :navigation-data="navigationData"
      :hide-sales-button="hideSalesButton"
      @onClose="toggleNavMenu()"
    />
  </div>
</template>

<style lang="scss">
.be-nav-tablet {
  *,
  ::before,
  ::after {
    box-sizing: border-box;
  }

  display: flex;
  align-items: center;
  justify-content: space-between;
  padding: $spacing-16 $spacing-8;
  background-color: $color-surface-50;
  @media (max-width: $breakpoint-sm) {
    display: none;
  }
}

.be-nav-phone {
  *,
  ::before,
  ::after {
    box-sizing: border-box;
  }
  background-color: $color-surface-50;
  // +1 Fixes bug of missing navigation at 576px by adding a +1 to the sm breakpoint.
  @media (min-width: #{$breakpoint-sm + 1}) {
    display: none;
  }

  .navigation-top {
    width: 100%;
    border-radius: 0;
    justify-content: center;

    &:hover {
      svg {
        fill: #000000;
      }
    }
  }

  .navigation-bottom {
    padding: $spacing-16;
    display: flex;
    align-items: center;
    justify-content: space-between;

    .search-icon {
      -webkit-appearance: none;
      appearance: none;
      color: $color-surface-700 !important;

      svg path {
        fill: $color-surface-700 !important;
      }
    }
  }
}
</style>
